/* goss.c   12x.30 stan swanson:  parse and decode beckyhilldances.txt */
/*  12e.01: older version attemping to parse dance extent --> hill.c */
# include <stdlib.h>
# include <stdio.h>
# include <string.h>
# include <ctype.h>
# define NEWDICT // to add or subtract code during debug of new dictionary

/*unsigned*/ char familiar[256];  // translation table for input, cf strange()
char filein[88], filestat[80], filedict[80],
     filecsv[80], fileglos[80], fileinfo[80], 
// input files, changeable on command line by user
     *defaultin="dances.txt",*defaultdict="dance-dict.txt",
     *defaultstat="dance-stat.txt",  
// output files, fixed names; not user changeable
     *defaultglos="words.out", *defaultcsv="out.csv", *defaultinfo="info.out";
FILE *fi,*fo,*d_fil,*fa;

// array sizes and string storage limits
# define Mxl   600  // line[Mxl] for input with fgets(line,Mxl-4,f)
# define Ms 400   // new dictionary terms:  kout<Ms, ksear<Ms  kstat<Ms
# define Mw 40    // maximum who's:       kwho<Mw  (old dict.)
# define Md 30    // maximum directions:  kdir<Md  (old dict.)
# define Ma 20    // maximum amounts:     kamt<Ma  (old dict.)
# define Mf 90    // maximum figures:     kfig<Mf  (old dict.)
# define Mi 100   // maximum stat columns for analysis:  kcol<Mi
# define Msd 10000  //  dictionary string storage size in by[]
# define Msl  6000  //  list string storage size in by[]
# define Msu  5000  //  summary string storage size in by[]
# define Mscr 4000  // scratch storage size, at beginning of by[]
# define Mby 50000  // size of by[]
# define Mox  2000  // size of occ[],  occ[j] is phrase "counter" for dance
# define oCat  500  // occ[j+oCat] is category of j-th dance token
# define oCod 1000  // occ[j+oCod] is out_code of j-th dance token
# define hPar   50  // hist[hPar+kpar]++
# define hTok  100  // hist[hTok+ii]++
# define hPun  224  // hist[hPun+9*semi+3*comma+lines]++
# define hOcc  300  // hist[hOcc+ocode]++ for statistics of dance tokens

// categories for dictionary and parsing
# define ZERO   0    // used for punctuation , ; backslash
# define ACT    1
# define WHO    2
# define DIR    3
# define MANY   4
# define PART   5
# define COMBO  6
# define IGNORE -1
# define MxCAT  7   // upper bound on categories for read_dict()
// modes for statistics
# define COUNT      0
# define TEXT       1
# define FIRST_CHAR 2
# define SYNOPSIS   3
# define QUALIFY    4
# define GROUP      5
# define ORDER      6
# define PIECES     7
# define MxMODE     8   // upper bound on statistics for read_analysis()

char *cat[20], *list[200], line[Mxl], by[Mby], *dict[Mox];
char *field[100], *backfield[100],*dance[Mi], whos[50],dirs[50],specials[100],
  title[80],zesty[20],howmany[12],*s1,*s2,*str=line,*si,*so,*null=NULL;
char *so,*smx, *sd,*sl,*su,*st, *sdmx,*slmx,*sumx,*stmx,  *clus,*cli;

char *str_ino,*str_in,*out_str[Ms],*sear_str[Ms],*stat_head[Mi];
int ksear, kout, mxio=Ms,ocodes[Ms],search_ix[Ms],categ[Ms];
int kcol,kstat,kshort,mxstat=Ms,stat_code[Ms],stat_col[Ms],stat_info[Ms],
  knt_col[Mi],col_info[Mi],tabu[Mi][40],short_code[Mi],short_list[Mi];
int heycode, gypcode;   // special outcodes for analysis
int klust,*kluster,klusters[Mi],klust_cols[Mi];
int tpiece, kpiece, korder, kombo; 
int qombo[Ms], combo[Ms], combo_info[Mox], combo_list[Mox];
int kerr=0,use_sd,use_sl,use_su,use_st,use_ox;   // error and limit counters...
//
FILE *fi,*fo,*d_fil,*fa;
int i,ii,j,jj,k,kk,knt,m,n, kdance,khead,kblnk,kombin,unkomb,krazy;
int k3=0, klist,kline,phead,qab,qdance, kd,occ[Mox],ix[Mox],hist[1000];;
int qdict=0,qsms=1,qopt=1,qcsv=1,aabb[6],kab,nab,qhead,qpr,qinfo,qexpt=0;
union { unsigned char c[4]; int i; } u; 
int pos_title,pos_author, qdbl_prog;

// utility filters for system string functions to catch NULL string arguments
//  I am tired of segmentation faults  !!!   COULD count errors...
int str_len(char *s1)
{ if (s1==NULL) return 0; return strlen(s1); }
char *str_cat(char *s1, char *s2)
{ if (s1==NULL) return NULL; if (s2==NULL) return s1; return strcat(s1,s2); }
char *str_ncat(char *s1, char *s2, int n)
{ if (s1==NULL) return NULL; if (s2==NULL || n<1) return s1;  
  return strncat(s1,s2,n); }
char *str_cpy(char *s1, char *s2)
{ if (s1==NULL) return NULL; if (s2==NULL) return s1;  
  return strcpy(s1,s2); }
char *str_ncpy(char *s1, char *s2, int n)
{ if (s1==NULL) return NULL; if (s2==NULL || n<1) return s1;  
  return strncpy(s1,s2,n); }
int str_cmp(char *s1, char *s2)
{ if (s1==NULL) return 1; if (s2==NULL) return -1;  
  return strcmp(s1,s2); }
int str_ncmp(char *s1, char *s2, int n)
{ if (s1==NULL) return 1; if (s2==NULL) return -1; if (n<1) return -2;  
  return strncmp(s1,s2,n); }
char *str_str(char *s1, char *s2)
{ if (s1==NULL) return NULL; if (s2==NULL) return NULL;  
  return strstr(s1,s2); }
char *str_tok(char *s1, char *s2)
{ if (s2==NULL) return NULL; return strtok(s1,s2); }
// end utility filters for NULL arguments....

/* insertion sort ia[0..n-1] with possible auxillary info xa[0..n-1]  */
/* Knuth, Numerical Recipes, cf vamp_utils.c */
int isort(int m, int *ia, int ka, int *xa)
{ int it,j,k,x=0,xx=0,xt;
  for (j=1;j<m;j++) { it = ia[j]; x = 0; if (ka) xt = xa[j];  
    for (k=j-1; k>=0; k--)
      { if (ia[k]<=it) break; ia[k+1] = ia[k]; x++; 
	if (ka) { xa[k+1] = xa[k]; }   
      } /* for (k>=0) */
    if (x) { ia[k+1] = it; xx += x; if (ka) xa[k+1] = xt; } 
  } /* for (j<m)  */
  return xx; } /* isort()  131.11 */

void ksort(int m, int *ia, char **xa)  // sort integers ia[], carry pointers
{ int it,j,k,x; char *xt;
  for (j=1;j<m;j++) { it = ia[j]; xt = xa[j]; x = 0;  
   for (k=j-1; k>=0; k--)
      { if (ia[k]>=it) break; ia[k+1] = ia[k];  xa[k+1] = xa[k]; x = 1;} 
    if (x) { ia[k+1] = it; xa[k+1] = xt; }  } /* for (j<m)  */  
} /* ksort()  131.14 */

void ssort(int m, char **xa, int *ia)
{ int it,j,k,x; char *xt;
  for (j=1;j<m;j++) {  xt = xa[j]; it = ia[j]; x = 0; 
    for (k=j-1; k>=0; k--)
    { if (str_cmp(xa[k],xt)<=0) break; 
            xa[k+1] = xa[k]; x = 1; ia[k+1] = ia[k]; } /* for (k>=0) */
    if (x) { xa[k+1] = xt; ia[k+1] = it; }  } /* for (j<m)  */  
} /* ssort()  131.14 */

FILE *openfile(char *name, char *deflt, char *mode)
{ FILE *f;    // conditional open of name; on failure, try default
  f = fopen(name,mode);    if (f) return f;    // success 
  printf(" can not open %s in mode %s, trying %s\n",name,mode,deflt);
  f = fopen(deflt,mode); if (f) return f;  
  printf(" open of %s failed also, returning null\n");
  return f;  /* let caller deal with failure */  }

int infield(void) // converts line[] to field[], returning number of fields
{ int i,j; char *si;
       field[0] = backfield[0] = si = str_tok(line," \t\n"); i = 0; 
       while (si) { i++; field[i] = backfield[i] = si = str_tok(null," \t"); 
                      if (i>90) break; }; /* while(si) */
       return i;  
} /* infield()  12e.22 */  /* add eol to separators, 12e.26 */

char *dan_types[13] = {"?","improper","imp","proper","prop","becket","mixer",
		      "sicilian","circle","triplet","face","longways","square"};
char dan_cat[13] = "?IIPPBMSCTFLQ";  int kdtyp=13,kdprog=3;
char *prog_types[3] = { "prog","double","triple" };

int dance_type(char *str) // find title, author, dance type from "= ..." line
{ int i,k,n,qhead=0;  pos_author = -1; pos_title = 1; qdbl_prog = 0;
  // find author presume "-" separator; look for "double prog"?
  n = str_len(str); 
  for (i=0;i<n;i++) if (str[i]=='-') { pos_author = i+1; break; } 
  // make lower case to search for type...
      str_cpy(so,str); for (i=0;i<n;i++) so[i] = tolower(so[i]);
      for (k=1;k<kdtyp;k++) if (str_str(so,dan_types[k])) { qhead = k; break; }
      if (str_str(so,prog_types[0])) // check for "prog"; then "double","triple"
	{ for (k=1;k<kdprog;k++) 
	    if (str_str(so,prog_types[k])) { qdbl_prog = k+1; break; }  }
      if (qhead==0) { printf("===phead %d aabb[0] %d knt %4d ?type? \n  %s\n",
			     phead,aabb[0],knt,str);
	for (i=0;i<klist;i++) printf("%s\n",list[i]); printf("-----\n\n"); }
 // 131.13  look for hint about piece count in title line: "#nn"
      tpiece = -1; 
      for (i=0;i<n;i++) if (str[i]=='#') { k = str[i+1];
	  if (isdigit(k)) { tpiece = k - '0'; k = str[i+2];
	    if (isdigit(k)) { tpiece = 10*tpiece + k - '0'; } }
 if (knt<qpr && tpiece>0) printf("title #%d\n",tpiece);
	  break; }   /* if (str[i]=='#') */
      return qhead; }  /* dance_type 12e.20 */

// look at first nonblank field in line..  (str == field[0])
//     decide if title, comment, section, text  (or blank??)

int line_type(char *str) 
{ int c,s,i,ii=0,p;  if (str==0) return -3;  // blank
    c = str[0] = toupper(str[0]); 
  if (c=='=') return 0;          // title
  if (c=='%') return -2;         // comment
  if (str_len(str) != 3) return -1;   // enforce (strlen == 3)
    i = str[1]; if (i=='1') ii = 1; else if (i=='2') ii = 2; 
    p = ispunct(str[2]);
// this accepts "A" "a" "B" "b" followed by "1" or "2" 
//       followed by any punctuation  (expect ":", may get "-" or ??? 
  if (c=='A') { if (ii && p) return ii; }
  if (c=='B') { if (ii && p) return 2 + ii; }
  return -1;  // other: text  (blank should have been caught before call)
} /* line_type() 131.19 */

// consider 16 beat sections A1, A2, B1, B2; deal with punctuation, 
//    compile statistics, convert to lower case, and save copy
int strain(int abi)  /* look at lines from aabb[abi] up to aabb[abi+1] */
{ int i,ie,j,k,n,c,klin=0,ksemi=0,komma=0,kfig,kpun=0;
  char *lin, *punpo[20]; 
    if (abi<1 || abi>4) 
      { printf(">>> phrases out of bounds %d\n  %s\n",abi,list[aabb[0]]); 
        return -1; } 
    i = aabb[abi]; ie = aabb[abi+1]; if (ie<=i) ie = klist-1; 
//  131.19 : line_type() possible out of order !!!
// check number of non-blank, non-comment lines
// keep original in list, copy to line at end
    list[klist+abi] = so; 
    for (k=i; k<ie; k++) { klin++; lin = list[k]; if (lin==null) klin--;
      else { if (lin[0]=='%') klin--; else { n = str_len(lin);
	  for (j=0;j<n;j++) { c = tolower(lin[j]); 
	    // what about tab character --> space ??
     //	    if (ispunct(c) && c!='/' && c!=':' && c!='\'' && c!='&') 
     //  131.13  only blank separate known syntactical punctuation
	    if (c==',' || c==';' || c=='(' || c==')')
	      { *so = ' '; so[1] = c; so[2] = ' '; if (so<smx) so += 3; }
	    else if (c=='%') { n = j; continue; }  // ignore to right of %
	    else { *so = c; if (so<smx) so++; }
	    if (c==';') { ksemi++; punpo[kpun] = so -2; kpun++; }
            if (c==',') { komma++; punpo[kpun] = so -2; kpun++; }
            } /* for (j) */
// line end mark  
         *so = ' '; so[1] = '\\'; so[2] = ' '; if (so<smx) so += 3; 
            punpo[kpun] = so - 2; kpun++; } /* not comment */
      } /* else not null */  } /* for (k) */ 

    *so = 0; if (so<smx) so++;   // terminate string
    k = so-list[klist+abi]; 
 if (k>296) { printf(">>> dance %d len %d\n",kdance,k); if (k>Mxl-4) kerr++; }
    kfig = klin; if (kfig>2) { kfig = 2; k3++; }
    if (klin==1 && (ksemi>0 || komma>0)) kfig = 2;
    hist[hPun+46+klin]++; hist[hPun+36+ksemi]++; hist[hPun+56+komma]++;
    k = klin-1; if (k>1) k = 2; j = ksemi; if (j>2) j = 2;
    i = komma; if (i>2) i = 2; n = hPun + 1 + 9*j + 3*i + k; hist[n]++;
   str_cpy(line,list[klist+abi]);   // retain for info.out
   if (so>=smx) printf("insufficient string storage in strain() \n");
   return kfig;
} /* strain()  12e.21 */

void debug_pr(int kk)
{
  //  printf("kk %d  %s\n",kk,line);
 for (j=0;j<kk;j++) printf("%s @ ",field[j]); printf("\n");
}  /* save some useful debug printouts...*/

int save_str(char* sav, char* str)  
{ int n; n=str_len(str); str_cpy(sav,str); return n; } /* 12e.26*/

//  char *str_ino,*str_in,*out_str[400],*sear_str[400];
//  int ksear, kout, ocodes[400],search_ix[400],categ[400];

// sort search terms so that longest come first; this deals with partial matches
int sort_dict(int qverb)   
{ int i,j,k,n,mx=512,off[20],len_in[20];
  printf("sort_dict, ksear %d\n",ksear);
// re-bin and check input tokens by size
  for (i=0;i<20;i++) len_in[i] = off[i] = 0;
  for (i=1; i<ksear; i++) { n = occ[i];
    if (n<1 || n>10) { printf("bad n %d at i %d\n",n,i); n = 0; }
    len_in[n]++; } 
  printf("------------\n");
    for (i=19,j=1;i>=0;i--) { k = len_in[i]; off[i] = j; 
             if (k==0) off[i] = ksear; j += k; 
     if (qverb && i<10) printf("i %d n %d ix off %d hi %d\n",i,k,off[i],j);
           }
  printf("------------\n");
    for (i=1; i<ksear; i++) 
    { k = occ[i]; j = off[k]; 
      if (j<0) { j = ksear; 
 	   if (qverb) printf("lo off %d at i %d  %s\n",j,i,sear_str[i]); } 
      if (j>ksear) { j = ksear; 
           if (qverb) printf("hi off %d at i %d  %s\n",j,i,sear_str[i]); }
        ix[i] = j; j++; off[k] = j; 
	  if (qverb) printf("i %d n %d  off %d new off %d\n",i,k,j,off[k]);
}
// now ix[j], j==1..ksear contains the index of sear_str[] in decreasing length
// i.e. sear_str[ix[i]] is in reverse order for (i++)...  how to rewrite?
// presume ksear<200 !!
    for (i=0; i<ksear; i++) dict[i] = sear_str[i];
    for (i=0; i<ksear; i++) 
      { j = ix[i]; sear_str[j] = dict[i]; ocodes[j] = occ[mx+i];         
 }
  printf("------------\n");
  for (i=1; i<ksear; i++) if (qverb) printf("sorted %s  key %d  out %s\n",
                                   sear_str[i],ocodes[i],out_str[ocodes[i]]);
    return 0;
} /* sort_dict() 12e.26 */

int read_dict(char *fil, int qlist) // new single list dictionary
{ int i,j,k,kf,kl,km,n,ieq,cat,key,ki,ko,mx=512,len_in[20],off[20]; 
  char *str, *outstr, *modif,*ostr;
  for (i=0;i<2;i++) printf("===========================\n");
  d_fil = openfile(fil,defaultdict,"r");  
    if (! d_fil) { printf("CAN NOT read new dictionary %s\n",fil); return -1; }
    printf(">>>> reading new dictionary %s\n",fil); 
    str_in = str_ino = sd;  kout = ksear = 1; kombo = kl = kerr = 0;
    for (i=0;i<20;i++) len_in[i] = 0;
    for (i=0;i<2*mx;i++) ix[i] = occ[i] = 0;
    for (i=0;i<Ms;i++) qombo[i] = combo_info[i] = 0;   // 131.10 new combo code
while (1) {  str = fgets(line,288,d_fil);  if (!str) break;
    n = str_len(line); line[n-1] = 0;  kl++;
    if (line[0]=='%') { if (kl<5) printf("%s\n",str); continue; } // comment
  //  if (qlist) printf("%s\n",line); 
     kf = infield();  if (qlist) debug_pr(kf);
 // ignore content after '%'
        k = 0; while (k<kf) if(field[k][0]== '%') break; else k++;  kf = k; 
    //  # define Ms 400
    //  char *str_ino,*str_in,*out_str[Ms],*sear_str[Ms];
    //  int ksear, kout, ocodes[Ms],search_ix[Ms],categ[Ms];
// consistency checks first:   '#', valid category, '='
     if (field[1][0] != '#') { kerr++; categ[key] = 0; 
        printf("# misplaced, line %d  %s\n",kl,field[0]); continue; }
// category quick and dirty: check first char for 
//     action, who, direction, how_much, part, combo
     k = tolower(field[2][0]); 
    if (k=='w') cat = WHO; else if (k=='d') cat = DIR; 
       else if (k=='h') cat = MANY; else if (k=='a') cat = ACT;
       else if (k=='c') cat = COMBO; else if (k=='p') cat = PART;
       else if (k=='i') cat = IGNORE; else cat = ZERO;
// look for position of '=': ieq>3 implies modifiers
    for (i=3,ieq=-1;i<kf;i++) if (field[i][0]=='=') { ieq = i; break;}
   if (ieq<0) { kerr++;   // no entries made for 'in' string
     for (j=0;j<kf;j++) printf("%s @ ",field[j]); printf("   kf %d\n",kf);
     printf("missing =, line %d kf %d  %s\n",kl,kf,outstr); continue; }
// get output string and position (key)
    n = save_str(str_in,field[0]); outstr = str_in;  
         str_in[n] = 0; str_in += n + 1; 
	 key = kout;  out_str[key] = outstr; //  kout++;    
    if (ZERO<cat && cat<MxCAT || cat==IGNORE) { categ[key] = cat; } 
       else { categ[key] = -10;  kerr++; kout = key; 
	 printf("bad key %s for %s\n\n",field[2],outstr); continue; }
if (ieq==3 && cat<COMBO) { // no modifiers: multiple in-strings, one out-string
    out_str[kout] = outstr; categ[kout] = cat; if (kout<Ms-1) kout++;
  for (i=ieq+1;i<kf;i++) { 
      n = save_str(str_in,field[i]); sear_str[ksear] = str_in; 
         str_in[n] = 0; str_in += n + 1; 
      occ[ksear] = n; occ[mx+ksear] = key; //    occ[ksear] = mx*n + key; 
        if (n==0) printf("zero length search string @ i == %d\n",i);
	len_in[n]++; if (ksear<Ms-1) ksear++;  
  } /* for (i<kf) */  } /* if (ieq==3*/
 else {  // either old style '... # action part = ...',  cat == ACT
         //     or new style '... # combo = parts ... ',      cat == COMBO
   if (qlist) printf("combination ieq %d kf %d delta %d  ?=? %s last: %s \n",
              ieq,kf,kf-ieq-1,field[ieq],field[kf-1]);
	if (cat!=COMBO) printf(">>>>read_dict() WARNING old style\n");
// modifiers;  should I warn about more than one?? 120.11 deprecate old style
    //    treat as output conjunction with two or three keys
    // parts are out code. search backwards to verify pre-definition
        out_str[kout] = str_in;  str_in[n] = 0; str_in += n + 1;

	for (i=0;i<kf;i++) { off[i] = -1; dict[i] = "@"; }
  for (k=3; k<ieq; k++) {  // outstrings before '='; usually subordinate
      n = save_str(str_in,field[k]); dict[k] = str_in; 
      str_in[n] = 0; str_in += n + 1;
      ki = -1; for (j=1;j<kout;j++) { if (out_str[j]==0) continue; 
        if (str_cmp(dict[k],out_str[j])==0) { ki = j; break; } }	
      if (ki<1) printf("combined action %s undefined\n",dict[k]); 
                else off[k] = ki; 
   } /* for (k<ieq) */	
   for (k=ieq+1; k<kf; k++) {  // outstrings after '='; usually dominant
      n = save_str(str_in,field[k]); dict[k] = str_in; 
      str_in[n] = 0; str_in += n + 1; 
      ki = -1; for (j=1;j<kout;j++) {  if (out_str[j]==0) continue; 
        if (str_cmp(dict[k],out_str[j])==0) { ki = j; break; } }	
      if (ki<1) printf("combined action %s undefined\n",dict[k]); 
                else off[k] = ki; 
//  131.10  need escape if ki<0 
   } /* for (k<kf) */
   if (cat==COMBO) { // new style # combo = [list of 2 or 3], anticipated order
      if (kf>ieq+4) 
           { printf("only binary or ternary combos allowed %s\n",outstr); 
             continue; }
      //    ki = off[ieq+1]; ko = off[ieq+2]; if (ko>ki) { j=ko; ko=ki; ki=j; }
      ki = off[ieq+1]; for (k=ieq+2;k<kf;k++) ki = 256*ki + off[k]; // 120.11
      if (ki>256) {  out_str[kout] = outstr; 
                     categ[kout] = -ki; if (kout<Ms-1) kout++; }
 /*  new code development, 131.10,  combo_list[], combo_info[], ... */
    //  combo_info[] has up to 4 "parts", a count (n), and an out_str number
// >>>> still need to sort off[ieq+1..k], i.e., keys in combo_info[]...
      n = kf - ieq - 1;  isort(n,off+ieq+1,0,off);
      for (k=ieq+1,j=kombo;k<kf;k++,j++) { ki = off[k]; 
	if (ki>0) { i = categ[ki]; if (i==ACT || i==PART) qombo[ki]++; 
	  combo_info[j] = ki; }   }  /* for (k<kf) */
      combo_info[kombo+4] = n;  ki = -1;
      for (j=0; j<kout; j++)   // find first instance
         if (str_cmp(outstr,out_str[j])==0) { ki = j; break; }
      combo_info[kombo+5] = ki; kombo += 6;
      // end 131.10 new code
   } else { /* old style # action ... = */

   printf(">>>> read_dict() REWRITE old style COMBO\n");
   } /*  else (cat==ACT) old style */
   } /* else (combined) */
  } /* while (1)  read to EOF */
    fclose(d_fil); 
    heycode = gypcode = -1;  // get special codes to unravel "gyp & swing"
    for (k=1;k<kout;k++) if (categ[k]==ACT) { 
        if (str_cmp(out_str[k],"hey")==0) heycode = k; 
        if (str_cmp(out_str[k],"gyp")==0) gypcode = k; }
    // 131.22  not used // printf("heycode %d gypcode %d\n",heycode,gypcode);
// 131.10 new combo info: lists of combos containing specfic parts or actions
    for (k=1,kl=1; k<kout; k++) { n = qombo[k]; if (n<1) continue;
      qombo[k] = kl; combo_list[kl] = n; kl++;
      for (kf=0; kf<kombo; kf += 6) { km = combo_info[kf+4];
        for (j=kf; j<kf+km; j++)   // indices of combos containing k
          if (combo_info[j]==k) { combo_list[kl] = kf; kl++; break; }
      }  /* for (kf<kombo) */
    } /* for (k<kout) scan qombo 131.10 */
//
    if (qlist) for (i= 0;i<10;i++) printf(" %d %d #",i,len_in[i]); printf("\n");
    //    for (i=10;i<20;i++) printf(" %d %d #",i,len_in[i]); printf("\n");
    printf("new dict: kout %d ksear %d kombo %d errors %d\n",
	   kout,ksear,kombo/6,kerr);
    if (kerr>0 || kout>Ms-2 || ksear>Ms-2 || kombo>Ms-2)
      printf(">>>>> error or possible overflow in read_dict()\n");
    if (str_in>=sdmx) printf(">>>>insufficient dictionary string storage\n");
    sort_dict(qlist);
    return ksear;
  } /* read_dict() (new)  12e.26 */

void pr_dict(FILE *f, int qverb)  // print contents of dictionary
{ int i,j,k, catk, ki,ko,n,nc, in[10]; char *outstr;
  if (!f) return;  // handle case of no info.out (fa==0)
  fprintf(f,"################\n#############\n");
   for (k=1;k<kout;k++) { catk = categ[k]; ki = ko = 0;
     outstr = out_str[k]; if (outstr==0) outstr = "_"; 
     for (j=1,i=0;j<ksear;j++) if (ocodes[j]==k) { in[i] = j; i++; }
   if (catk<0) { ki = (-catk)/Ms; ko = (-catk)%Ms;   if (qverb>0) 
       fprintf(f,"%3d %s combined categ %d %d %d\n",k,outstr,catk,ki,ko); 
     continue; }  /* if (catk<0) */
   if (qverb>0) { fprintf(f,"%3d %s categ %d # ",k,outstr,catk);
     for (j=0;j<i;j++) printf(" %s",sear_str[in[j]]); printf("\n"); }
   } /* for (k<kout) */
   if (qverb>0) {
   for (k=0;k<kout;k++) { ki = qombo[k]; if (ki==0) continue;  
     n = combo_list[ki]; fprintf(f,"combo part %s  %d\n",out_str[k],n);
     for (i=0;i<n;i++) { ko = combo_list[ki+i+1]; nc = combo_info[ko+4];
       fprintf(f,"%s ## combo == ",out_str[combo_info[ko+5]]);
       for (j=0;j<nc;j++) fprintf(f," %s", out_str[combo_info[ko+j]]); 
       fprintf(f,"\n"); }  /* for (i<n} */ 
  } /* for (k<kout) */
   fprintf(f,"################\n#############\n"); } /* if (qverb>0) */
 } /* pr_dict() 12e.28 131,22 */

int read_stats(char *fil, int qverb) // directions for analysis
{ int i,ii,j,k,kk,kq,kl,kod,info,n,ic,gr,q,kin=0;
  printf("===========================cvs stats=====\n");
  d_fil = openfile(fil,defaultstat,"r");  
    if (! d_fil) { printf("CAN NOT read stat file %s\n",fil); return -1; }
      printf(">>>> reading stat file  %s\n",fil);  
      kcol = kstat = kshort = klust = 0; 
    while (1) { str = fgets(line,288,d_fil); if (!str) break; 
      n = str_len(line); line[n-1] = 0; str_cpy(by,line); kin++;
      if (line[0]=='%') { if (kin<5) printf("%s\n",by); continue; }
      //      if (kerr) printf("= = = kerr %d line %d\n",kerr,kin);
      kk = infield(); i = 0; 
        k = 0; while (k<kk) if(field[k][0]== '%') break; else k++;
      kk = k;    if (kk==0) continue;  //  ignore content to right of '%'
      if (kk<4) { printf("short stat line %s\n",by); kerr++; continue; }
      // for (j=0;j<kk;j++) printf("%s @ ",field[j]); printf("\n");
      //
      //  column_head # info = [list of output strings]
      //  column_head # qualify = [required actions] > [symbols tabulated]
      //
        // field[0] is header text
        // field[1] should be '#'
        // field[2] is info:  
           // count, text, first-char, short, qualify, order, pieces
        // field[3] should be '='
        // field[4..] are output strings to be monitored
        // in case of 'qualify' or 'order', '>' appears between 
        // required actions and reported symbols (usually who or direction) 
if (field[1][0] != '#') { printf("bad # stat line %s\n",by); kerr++; continue; }
if (field[3][0] != '=') { printf("bad = stat line %s\n",by); kerr++; continue; }
      n = save_str(str_in,field[0]); stat_head[kcol] = str_in; 
             str_in[n] = 0; str_in += n + 1; kq = kl = 4;       
             kod = -1; info = COUNT;  /* default to count */
	     ic = tolower(field[2][0]); 
	 if (ic=='c') info = COUNT; else   // count
	 if (ic=='t') info = TEXT;  else   // text
	 if (ic=='f') info = FIRST_CHAR; else   // first-char
	 if (ic=='s') info = SYNOPSIS;   else   // synopsis
	 if (ic=='p') { info = PIECES;   // piece count, extra column for #zesty
           col_info[kcol] = -info;  if (kcol<Mi) kcol++;  
           stat_head[kcol] = stat_head[kcol-1];  // duplicate header...
	 } else    
	 if (ic=='q' || ic=='o') { info = QUALIFY;     // qualify
	     if (ic=='o') info = ORDER;  // same right side "= .. > ..."
	   while (kl<kk) if(field[kl][0]== '>') break; else kl++;
      if (kl>=kk) { printf("missing > stat line %s\n",by); kerr++; continue; }
      for (ii=kq; ii<kl; ii++) { q = 1; // check manditory action[s] for column 
	    for (k=1;k<kout;k++) { if (str_cmp(out_str[k],field[ii])==0)
	     { stat_code[kstat] = kod = k; stat_info[kstat] = -info; q = 0;
   if (qverb) printf("qualify/order %s col %d info %d\n",field[ii],kcol,info); 
	      stat_col[kstat] = kcol; if (kstat<Ms) kstat++; continue;}
 	     } /* for (k<kout) */
	    if (q) { printf("undefined symbol %s\n",field[ii]); kerr++; } 
           } /* for (ii<kl) */
	   kl++; 
         } /* (info==QUALIFY || info==ORDER)*/
	 else if (ic=='g') { info = GROUP;  kl = kk;
	   for (ii=kq,k=0; ii<kk; ii++) // either absolute >= 0 or relative < 0
             { gr = atoi(field[ii]); if (gr<0) gr += kcol; ix[k] = gr; k++; }
	   if (1 || qverb) {
             printf("group %s column %d   heads: ",stat_head[kcol],kcol); 
               for (i=0;i<k;i++) printf (" %s ",stat_head[ix[i]]);
             printf("\n            column numbers:  "); 
	     for (i=0;i<k;i++) printf ("%d ",ix[i]); 
             printf("\n"); }  /* if (1 || qverb) */

	   // record columns for cluster analysis
	   klusters[kcol] = klust; kluster = klust_cols + klust;
	   *kluster = k; for (i=0;i<k;i++) kluster[i+1] = ix[i]; klust += k + 1;

	 } /* info == "group"    columns for clustering */

  // now remember out ocodes (should all be actions) for stats
	       //  ?? int search(int i, int lim, char **what, int *code) 
    for (ii=kl; ii<kk; ii++) { q = 1;
	for (k=1;k<kout;k++) { if (str_cmp(out_str[k],field[ii])==0)
	   { stat_code[kstat] = kod = k; stat_info[kstat] = info; q = 0; 
	     if (qverb) printf("anal %s col %d info %d\n",field[ii],kcol,info); 
	   stat_col[kstat] = kcol; if (kstat<Ms) kstat++; continue; } /* if */
	} /* for (k<kout) */
  // output symbol not found;  add flag if PIECES ...
	  if (q && info==PIECES) { // add symbol as PART (e.g. "#"  "@"
             n = save_str(str_in,field[ii]); out_str[kout] = str_in;  
             str_in[n] = 0; str_in += n + 1;   categ[kout] = PART;
     printf("adding PIECES flag %s col %d info %d\n",field[ii],kcol,info); 
             stat_code[kstat] = kout; stat_info[kstat] = info; 
	     stat_col[kstat] = kcol; 
             if (kstat<Ms) kstat++; if (kout<Ms) kout++; continue;  
	  } else if (q) { printf("undefined symbol %s\n",field[ii]); kerr++; }
      } /* for (ii<kk) */
      col_info[kcol] = info; if (kcol<Mi) kcol++;
    } /* while (1) */
    fclose(d_fil);  
    printf("\n>>>>csv kcol %d kstat %d group cols %d ",kcol,kstat,klust);
    for (k=0;k<klust;k++) printf("%d ",klust_cols[k]); printf("\n");
    if (kstat>=Ms) printf(">>>>>too many analysis entries\n");
    if (kcol >=Mi) printf(">>>>>too many analysis columns\n");
    if (str_in>=sdmx) printf(">>>>insufficient analysis string storage\n");
    if (kerr) printf("### cumulative errors %d\n",kerr);
      use_sd = str_in - sd;  // record usage
    return kcol;
} /* read_stats()  12e.27*/

// need bounds check on dict[Mox]...   120.13
// find unique tokens in filein, report counts in fileglos
void makedict(int kk)   // called when qdict is true
{   int i,ii,jj,k;
	if (knt<qpr) printf("%s\n%s\n",str,line);
       field[0] = si = str_tok(line," \t"); i = 0; 

       while (si) { i++; // field[i] = si = str_tok(null," ,;()-\t"); 
                      field[i] = si = str_tok(null," \t"); 
                      if (i>90) break; }; /* while(si) */
       if (knt<qpr) { for (ii=0; ii<i; ii++)  printf("%s @ ",field[ii]);
	              printf("\n"); } 
       for (ii=0;ii<i;ii++) { str = field[ii]; jj = 1;
         for (k=0;k<kd;k++) 
           { if (str_cmp(str,dict[k])==0) { occ[k]++; jj = 0; break; } }
	 if (jj) { occ[kd] = 1; n = str_len(str); dict[kd] = sd; 
           if (kd<Mox-4) kd++;
	   for (j=0; j<=n; j++) sd[j] = str[j];   sd += n+1; }
       } /* for (ii) */
       //       if (knt<qpr) printf("kd %d %s\n",kd,dict[kd-1]);
} /* makedict() 12e.22 */

 // search for tokens in dictionary, returns outcode to output string
int search(int i, int lim, char **what, int *code) 
{ int k,m=-1,lf=2;  char *fld;  
  fld = field[i];  if (! fld) return m;  if(fld[1]==0) lf = 1;
  for (k=1; k<lim; k++) { if (str_str(fld,what[k]))  // pointer into s1 for s2 
      { if (what[k][1]==0 && lf>1) continue; 
  // 12e.24  double check for one letter what[m] (r,l,p,n,...) is len(fld)==1?
  // marking used items (may not be necessary), still in backfield[]
        m = k; field[i] = null; break; }  }
  return m;  
} /* search() 12e.22 */

/* 12e.23  eliminate strange character sequences from dance input file.
       These probably come in converting MS Word .doc into .txt.

   \342 \200 n, where n is \223 '-', \231 ''', \234 and \235 probably `` ''
                           \246  ~ ?,  \250
  plus about 4 of \302 \240, and an initial  \357 \273 \277
*/

int replace[] = {0223,0240,0231,0246,0234,0235,0224,0251,0250,0230};
char *withr="-:' ""-e '", with[20];
int nrepl=10, nign=7 , ignore[] = {0357,0273,0277,0342,0200,0303,0302};

int ox, phx, pflag, stx;
void init_stat(int kk)  // initializes hist[]... call before analysing A1..B2   
{ int i;  
  if (kk<0) { for (i=0; i<1000; i++) hist[i] = 0; 
    // translation table to replace unusual MS Word graphics with ASCII equivs.
    for (i=0;i<256;i++) { familiar[i] = i; } 
    for (i=0;i<nrepl;i++) { k = replace[i]; familiar[k] = withr[i]; }
    for (i=0;i<nign;i++) familiar[ignore[i]] = 0;
       //  familiar[replace[0]] = 0;  // already 0 
    return; } // (kk<0) file stats and translation table
  if (kk==0) { for (i=0; i<2000; i++) occ[i] = 0; 
    if (knt<qpr) printf("init_stat knt %d kk %d\n",knt,kk);
                ox = 0; pflag = phx = stx = 0; return;}
  stx = 20*kk; phx = 0;  return;
  // should get histograms of tokens/strain, how many punctuation changes
} /* init_stat()  12e.22 */

void stat(int it, int ix, int loc, int *code, int st)
{ int key;     
     //  if (knt<qpr) printf("stat it %d i %d match %d\n",it,ix,loc);
  // 'it' is category, 'ix' is index into line, 'st' is which strain
  // 'loc' is match within category_in[], <0 if no match; code[loc] is output 
  if (it==0) { /*punctuation*/  // 112e.29 move this back to parse()
    // if (loc==',' || loc==';' || loc=='\\') phx +=2;
    // else if (loc=='(') { /* phx++; */  pflag = 1; } 
    // else if (loc==')') { /* phx--; */  pflag = 0; }
    return;  }  // do not put punctuation in occ[] for now...
  if (loc<0) return; // no match
  key = code[loc];     // discard synonyms (e.g. left, lft, l)
  if (pflag) return;   // see if this is more tractable
  occ[ox] = stx+phx+pflag; 
  occ[ox+oCat] = it; occ[ox+oCod] = key; ox++; return;
} /* stat()  12e.22 */

void nuisance(int len) // eliminate words like "and" from input
// 12e.28  think about tab --> space
{  int i,n;                     // make into zero length string
  for (i=0; i<len; i++) if (str_ncmp(field[i],"and",3)==0) field[i][0] = 0;
}  /* nuisance()   12e.23 */

// find tokens in dance description, phrase separations, fill occ[0..ox]
//     ignores tokens between parentheses  "( ignore all this )"
void parse(int kk, int n) // kk == 1..4 for A1..B2 strains. n == # lines 
{  int i,ii,jj,k,cat,cod,komma=0,ksemi=0,kpar=0,pp;
   	if (knt<qpr) printf("%s\n%s\n",str,line);
 // line contains all data in A1, A2, B1, or B2; conbined into line by strain()
      ii = infield();        // find punctuation ','  ';'  '\'
      nuisance(ii);
      // need get_punct(), get_fig(), get_who(), get_dir(), get_amt()
         init_stat(kk);  // jump stx
      // ignore field[0] which has "a1: a2: b1: or b2:"
  for (i=1;i<ii;i++) { si = field[i]; pp = si[0];  
# if (0)  // 131.20 all strings with initial punctuation were caught here
	if (ispunct(pp)) { if (pp==',') komma++;  if (pp==';') ksemi++;
          if (pp==',' || pp==';' || pp=='\\') phx +=2;
	  if (pp=='(') { pflag = 1; kpar++;};
	  if (pp==')') { pflag = 0; kpar++;};
	}  /* if (ispunct()) */
# endif
        if (pp==',' || pp==';' || pp=='\\') { phx +=2;
	  if (pp==',') komma++;  if (pp==';') ksemi++; }
	else if (pp=='(') { pflag = 1; kpar++;}
	else if (pp==')') { pflag = 0; kpar++;}
// 131.20  some initial punctuation allowed, just not ", ; \\ ( ) "
        else { k = search(i,ksear,sear_str,ocodes);  
          cod = ocodes[k]; cat = categ[cod]; 
	     //       stat(cat,i,cod,ocodes,kk);  // 12e.29 avoid stat()
	  if  (knt<qpr) printf("parse %s ixsear %d cod %d out %s cat %d\n",
			       si,k,cod,out_str[cod],cat);
          if (pflag) continue;  // do not record parenthesized info in  occ[]
             occ[ox] = stx+phx+pflag; 
         occ[ox+oCat] = cat; occ[ox+oCod] = cod; ox++; 
	} /* else search */

      } /* for (i) */
	i = komma + ksemi + n; hist[i]++;  // separators per strain (<40)
        hist[hPar+kpar]++;  // parentheses
        hist[hTok+ii]++;  // tokens per strain

} /* parse() 12e.22 */

void occ_pr(FILE *fil, int lo, int hi)  // print occ[lo..hi]
{ int i,ph,cat,cod,key,abkey,kx; char *prose;
     fprintf(fil,"===occ_pr  kdance %d ox %d   %s\n",kdance,ox,list[aabb[0]]);
	for (i=lo;i<hi;i++) {  // was i<ox
          ph = occ[i]; cat = occ[i+oCat]; abkey = key = occ[i+oCod];
	  if (key<0) abkey = -key;
          if (abkey>0 && abkey<kout) prose = out_str[abkey]; else prose = "?";

	  fprintf(fil,"%5d  categ %2d  key %3d out %s ",ph,cat,key,prose);
          fprintf(fil,"\n");
	} /* for (lo<=i<hi) */
} /* occ_pr()  12e.23, 120.13 */

//  possible order enforcing with:
//  u.c[0] = 0; u.c[1] = 1; u.c[2] = 2; u.c[3] = 3;
//  printf("u.i %x u.c[3] %x\n", u.i, u.c[3]);

// some figures are specified with multiple tokens e.g. " R and L thru "
      // look for PARTs in occ[], combine with COMBO if possible
int combine(int qverb) 
{ int i,ii,j,jj,k,kk,ki, n,nn, komb, catk,codk,phr,phi,pho,new,old,qunk=0,
    kp,kc,km,ku, p0,c0,part[40],cod[40],pos[40],used[40];

  // pass one to combine:  do multiple (2 || 3) explicit parts first
    new = old = occ[0];  kp = komb = qunk = codk = ki = 0;

    for (k=0;k<ox;k++) { new = occ[k]; 
    if (new>old) { // at phrase  boundary;  (kp>1) multiple "PART"s 
      if (kp) { for (i=ki,ii=0;i<k;i++,ii++) 
	  { cod[ii] = occ[i+oCod]; pos[ii] = i; }
	  isort(ii,cod,1,pos);   //  ii is move count for current phrase
	  cod[ii] = pos[ii] = -1;  // debug marker

	for (i=0;i<kp;i++) { kk = qombo[part[i]]; nn = combo_list[kk]; kk++;
	  for (jj=0;jj<nn;jj++,kk++) { kc = combo_list[kk];
            n = combo_info[kc+4]; km = kc + n; j = 0; codk = 0;
// match combo_info[kc..kc+n-1] to cod[0..ii-1]; each is sorted small to large
	    while (j<ii && kc<km) {
	    if (cod[j]==combo_info[kc]) { kc++; j++; 
 //   if (fa) fprintf(fa,"== cod %d j %d kc %d\n",cod[j],j,kc);
	      if (kc>=km) { codk = 1; break; }  /* match */  }
	    else if (cod[j]<combo_info[kc]) { j++; } 
	    else if (cod[j]>combo_info[kc]) { break; }
	    } /* while (j,kc) */ 
	    if (codk) break;
	  } /* for (jj<nn), try to match combo[jj] to cod[] */
	  if (codk>0) { kc = combo_list[kk]; komb++;  ku = 0;  
 //   if (fa) fprintf(fa,"match kk %d kc %d  ",kk,kc);  //debug
	    for (j=0;j<ii;j++)  // zero out occ[] elements for combo 
	      {  if (cod[j]==combo_info[kc])
		  { occ[pos[j]+oCod] = occ[pos[j]+oCat] = 0;
		    if (categ[cod[j]]==PART) qunk--;  ku++;
 //   if (fa) fprintf(fa," %s",out_str[cod[j]]);
	         kc++; if (kc>=km) { /* fprintf(fa,"\n"); */  break; }  
		  } /* if (cod[j]==) */
	      } /* for (j<ii) */
	    if (qunk>0) { unkomb++;  if (fa) {
    fprintf(fa,"##### uncombined kp %d ku %d ",kp,ku);
    for (j=0;j<kp;j++) fprintf(fa," %s",out_str[part[j]]); fprintf(fa,"\n");} 
	    } /* if (qunk) */
            if (j>=ii) j = ii - 1; occ[pos[j]+oCat] = ACT;
	    occ[pos[j]+oCod] = combo_info[combo_list[kk]+5];
	  } /* if (codk) */
// ??  how to cut short redundant searches ??
	  if (ku==kp) break;   /* this is quick and dirty...could zero */
	} /* for (i<kp) */
      }  /* if (kp)   candidate parts for combos */
      old = new; kp = codk = 0; ki = k;  qunk = 0; // start new "phrase"
    } /* new>old */

      codk = occ[k+oCod]; 
      if (qombo[codk]) { part[kp] = codk; kp++; 
                         if (categ[codk]==PART) qunk++; } 
      if (knt<qpr) printf("combine occix %d cod %d ocod %d dance %d\n",
			  k,codk,occ[k+oCod],kdance);
  } /* for (k<ox) */


// pass two:  compactify
  for (k=kk=0;k<ox;k++) { occ[kk]=occ[k]; i = occ[kk+oCat] = occ[k+oCat];
    j = occ[kk+oCod] = occ[k+oCod]; if (i) kk++; 
    if (0<j && j<kout) hist[hOcc+j]++;  // count occurrences of output tokens  
  } /* for (k<ox) */
  ox = kk;
       if (komb>0 && knt<qpr) 
       printf("####  %d combos in dance %d\n",komb,kdance);
  return komb;
}  /* combine()  120.11 */

// transform MS word special chars to ASCII; eliminates some hand editing
//    familiar[] is initialized in init_stat()
void strange(char *buf, int len) 
{ int i,j,k,c;
  for (i=j=0; i<len; i++) { k = buf[i]; if (k<0) k += 256; 
     buf[j] = c = familiar[k]; 
     if (c>0) j++; else if (c<0) 
     { krazy++; familiar[k] = 0; // count only once
       if (fa) fprintf(fa,"????? untranslated char %o in line %d at %d\n",
		       c+256,knt,i);
     } /* if (c<0) */  
  } /* for (i<len) */
    for (i=j; i<len; i++) buf[i] = 0; // zero rest of buffer 
  return;
} /* strange() 120.13 */

// helper routines for making and outputting .csv file...
void csvoutnum(int n)  // n>0
{  if (n>0) fprintf(fo,"%d,",n); else fprintf(fo,",");}
void csvoutstr(char *str)  // str has some characters
{  if (!str) { fprintf(fo,","); return; }   // deal with null pointer
   if (str[0]!=0) fprintf(fo,"\"%s\",",str); else fprintf(fo,",");}
void csvaddchar(char c, char *str)  // assumes str has enough zeros at end
{ int n; if (!str) return;  n = str_len(str); str[n] = c; }

int uniquify(int kount, int *list)
{ int i,j,k,x;    // eliminate duplicates, keep original order of first instance
  for (i=j=0;i<kount;i++) { x = list[i]; if (x==0) continue; // already on list
    list[j] = x; j++;
    for (k=i+1;k<kount;k++) if (list[k]==x) list[k] = 0; } /* for (i<kount) */
  return j; } /* uniquify() 120.02 returns reduced count */

void pr_summary(FILE*, int);  // prototypes for end of program printouts
void pr_storage(FILE*);

void main(int argc, char *argv[])
{ int qprd,qprab,qprsu,qprst,qinfo;
 // defaults...
      qprd = 0; qprab = 0; qprsu = 0; qprst = 0;
      qdict = 0; qinfo = 0; qexpt = 0;

  str_cpy(filein,defaultin); str_cpy(filedict,defaultdict); 
  str_cpy(filestat,defaultstat); 
  str_cpy(filecsv,defaultcsv); str_cpy(fileglos,defaultglos);  
  str_cpy(fileinfo,defaultinfo);  

// preparation for command line arguments
//  printf("options [-d] ... [-i alternate_dance_file] ");   
//  printf("========== %s argc %d\n",argv[0],argc);
  if (argc>1) {
    if (str_cmp(argv[1],"-h")==0) { 
      printf("pick, a contra dance analysis program, compiled %s at %s\n",
	     __DATE__,__TIME__);
      printf("    Author: Stan Swanson. License: GPL\n\n"); 
      printf("usage:  pick              (use dances.txt as input)\n"
             "usage:  pick mydances     (use mydances as input) \n"
             "usage:  pick [options]    (use default infile only) \n"
             "usage:  pick [options] mydances (should be ok) \n\n");
        printf("options:\n  -h  (help: print this and exit)\n"
        "  -s  your_statistics_file \n"
        "  -d  your_dictionary_file \n"
        "  -w  (Word list and counts, Note: uses output file %s)\n"
        "  -i  (additional information: uses output file %s)\n"
        "  -e  (enable experimental code)\n"
	       "  -b  [debug print count]\n",fileglos,fileinfo);

    printf("default input files:  dances, dictionary, statistics:\n"
           "                      %s,  %s,  %s\n",filein,filedict,filestat);
    printf("       output files:  csv, info, word_count:\n"
           "                      %s,  %s,  %s\n",filecsv,fileinfo,fileglos);
        exit(0); }  // help printout

  for (i=1; i<argc; i++) printf("%2d %s\n",i,argv[i]); // echo arguments
  if (argc==2 && argv[1][0] != '-') 
    { str_cpy(filein,argv[1]); }  // change infile only 
  else {  // change other files, but use default infile -- do not overwrite 
  for (i=1; i<argc; ) {  printf("%2d %s\n",i,argv[i]);
    // infile should be ok here, if user can not specify output files
  if (i==argc-1 && argv[i][0] != '-') 
    { str_cpy(filein,argv[i]); }  // change infile only 
  // statistics
    if (str_cmp(argv[i],"-s")==0) { i++; if (i>=argc) break; 
      if (argv[i][0] != '-') { str_cpy(filestat,argv[i]); i++; continue;} }
  // dictionary
    if (str_cmp(argv[i],"-d")==0) { i++; if (i>=argc) break; 
      if (argv[i][0] != '-') { str_cpy(filedict,argv[i]); i++; continue;} }
  // make glossary
    if (str_cmp(argv[i],"-w")==0) { qdict = 1; i++; continue; }
  // write info 
    if (str_cmp(argv[i],"-i")==0) { qinfo = 1; i++; continue; }
  // enable experimental code  (e.g. AA BB AABB )
    if (str_cmp(argv[i],"-e")==0) { qexpt = 1; i++; continue; }
  // debug
    if (str_cmp(argv[i],"-b")==0) { qinfo = 1; i++; if (i>=argc) break;
          n = sscanf(argv[i],"%d",&qpr); 
	  if (n==1) { qprd = qprab = qprsu = qprst = qpr; i++; continue;}  }
    i++;  /* avoid infinite loop if bad input  */ 
  } /* for (i<argc) */   
  } /* else other file changes */ 
} /* if (argc>1) parse command line */

  fi = openfile(filein,defaultin,"r");  
  if (!fi) exit(-1); 
   knt = 0;  fa = 0; //  

      // bases for saving strings
      sd = by +  Mscr;    // dictionary strings
      sl = sd +  Msd;     // save strings in list[]: input, strains
      su = sl +  Msl;     // summary
      st = su +  Msu + Mi*50;   // statistics work area  ??? Mi*50 in st !!!
      clus = cli = st + 10000;    // not using this now (no cluster analysis)
   // maxima for string storage regions
      sdmx = sl - 8;  slmx = su - 8; sumx = st - 8;  
      stmx = clus -8;  // stmx = by + Mby - 8;
      use_sd = use_sl = use_su = use_st = use_ox = 0;      // maximum usage
      //  printf("cluster work space %d\n",by+Mby-clus);

//  open files

    if (qcsv && !qdict) { fo = openfile(filecsv,defaultcsv,"w");
      if (!fo) { printf("### bad csv file using stdout\n"); fo = stdout; }
      if (qinfo) fa = openfile(fileinfo,defaultinfo,"w");  
    } /* if (qcsv)  open fo,fa; output header line */

    qpr = qprd;
// initialize dictionary if parsing
    if (!qdict) { k = read_dict(filedict,0); if (k<0) exit(-1);
      pr_dict(stdout,qpr); pr_dict(fa,qpr+1); 
      kcol = 0; k = read_stats(filestat,0); if (k<0) exit(-1); } 

    if (qcsv) {
// output spread sheet column headers in first line
      fprintf(fo,"\"' title\",\"' author\",\"' type\",\"' summary\",,");
// statistics column headers
      for (k=0; k<kcol; k++) fprintf(fo,"\"' %s\",",stat_head[k]); 
// second copy of title
      fprintf(fo,"\"' title\","); 
// uniquified synopses
      if (qexpt) fprintf(fo,"\"' AA\",\"' BB\",\"' AABB\","); 
// and sort column for original sequence
          fprintf(fo,"0\n");    // sort column to original order
    } /* if (qcsv) */

    init_stat(-1);   // initialize histogram, etc.
    printf("=================\n===============\n");

    kblnk = kab = nab = kdance = khead = kombin = unkomb = krazy = 0; 
        kline = klist = kd = 0;  
    qab = 0; qpr = 0; qdance = qhead = 0; phead = -1;
      for (i=0;i<6;i++) aabb[i] = 0;    
      //??          if (use_sd<so-sd) use_sd = so-sd;  // keep maximum usage
      so = sl; smx = slmx;  // so,smx: working pointer and limit for lines;  
                             // str, si:   temporaries
      while (1) { str = si = fgets(line,Mxl-4,fi); 
    if (!str && kab==0) break;  knt++;   // valid line
    // debug stuff
    //    if (knt==40) qpr = 70;  
qpr = qprab;
    n = k = str_len(str);  if (n>0) k--; str[k] = 0; // erase \n or \r
    strange(str,k);  // eliminate strange graphic characters from MS word ...
    // copy, changing to lower case....  (do that in parse??

// delineate dance: title A1 ... A2 ... B1 ... B2 ... [%,blank,=]
// check for title line: either before AABB, or second title after
// copy ...
  list[klist] = so; kk = klist; klist++; 
      for (i=0; i<n; i++) { *so = line[i]; if (so<smx) so++; } 
 // make sure saved string terminates 
      if (*(so-1) != 0) { *so = 0; if (so<smx) so++; }

    if (!si) { printf("null line in at %d\n",knt); continue; }  
                // 131.19 ? continue
    else { field[0] = str_tok(si," \t");     ///  i = 0; }

  // flag blank line as comment...
    if (field[0]==null) { field[0] = so = list[klist-1]; *so = '%'; 
                          so[1] = 0; if (so<smx) so += 2; }
         
/* title stuff */
      if (field[0][0]=='=') { if (phead<0) { aabb[0] = kk; phead = kk; } 
	                      else aabb[5] = kk; }
/* other types of lines: section, comment? blank? ... */
      else { ii = line_type(field[0]);
        if (ii>0) { aabb[ii] = kk; nab++; qab = 1; kab += 1<<(ii-1); }
	else if (ii< -2) printf("line type %d %s\n",ii,line);
      } /* else (field[0][0] != '=') */
    } /* if (si)  */
 
    if (phead<0) klist--;   // ignore lines before title...

// found B2: and following separator field... analyse dance
    if (aabb[4]>0 && (field[0][0]=='%' || field[0][0]=='=') )
    { qhead = dance_type(list[aabb[0]]); kdance++; khead++; // title
      if (qdict) {
        for (kk=1;kk<5;kk++) { si = str = list[aabb[kk]]; 
	    n = strain(kk);
	    makedict(kk);
          } /* for (kk) */
      } else {  /*analyse*/

      init_stat(0);  // init occ[] for each dance  
      for (kk=1;kk<5;kk++) { si = str = list[aabb[kk]]; 
	n = strain(kk);   parse(kk,n);
      } /* for (kk) */

 // terminate B2: with a fake C1: to get last phrase
      occ[ox] = 100; occ[ox+oCat] = ACT; occ[ox+oCod] = 0;  ox++; 
     k = combine(0); kombin += k; // combine parts into actions  120.11
 //   debug 131.01 find zero occ entry
     if (knt<300 && 0) { for (kk=0;kk<ox;kk++) if (occ[kk+oCod]==0)
	  printf("ocode zero for k %d,  ox %d kdance %d\n",kk,ox,kdance);
     }
   if (use_sl<so-sl) use_sl = so-sl;  // keep maximum usage of list space

 // print analysis ...  selectively based on debug line limit qpr
     if (knt<qpr) occ_pr(stdout,0,ox); 

      if (qcsv) {       //  output .csv file
	// title, author, and type fields
        str_cpy(line,list[aabb[0]]); line[0] = ' '; n = infield(); zesty[0] = 0;
	for (i=j=0;i<n;i++)  if (field[i][0]=='-') j=i;  
	  else if (field[i][0]=='#')    // limit copy to 10 chars...
                  { str_ncpy(zesty,field[i],10); zesty[10] = 0; }
        so = su;  smx = sumx;  // base and limit for summary strings
        title[0] = 0;   // save title 
	for (i=0;i<j;i++) { str_cat(title,field[i]); str_cat(title," "); }
        csvoutstr(title);    // author after '-', take only two words
	if (fa) { fprintf(fa,"=%s\n",title);
	  for (i=1;i<5;i++)  fprintf(fa,"%s\n",list[klist+i]);  }

        so = su;  *so = 0;  if (j+3<n) n = j+3; 
	for (i=j+1;i<n;i++) { str_cat(so,field[i]); str_cat(so," "); }
        csvoutstr(so);
	//        so = su;  *so = dancecateg[qhead][0]; so[1] = so[2] = 0; 
        so = su;  *so = dan_cat[qhead]; so[1] = so[2] = 0; 
	if (qdbl_prog) so[1] = '0' + qdbl_prog;  csvoutstr(so); 
 // make dance summary here
 qpr = qprsu;
   { int k,ki, spec[Mi], old,new, olds, news, catk,figk,codk,spek,key;  
     int kp[Mi],plo,phi,pun,is,cs,kw,kd,ka,lastact[Mi],dirlist[Mi];  

     so = su;  k = 50*MxCAT;  for (i=0;i<k;i++) so[i] = 0;
     for (i=0;i<MxCAT;i++) { kp[i] = spec[i] = 0; dance[i] = so; so += 50; }
// 131.21 do not really need dance[0..kcol] for scratch
//     so = su;  k = 50*kcol;  for (i=0;i<k;i++) so[i] = 0;
//     for (i=0;i<kcol;i++) { kp[i] = spec[i] = 0; dance[i] = so; so += 50; }

     so += 100; *so = 0; old = occ[0]; olds = old/20;
     phi = plo = pun = 0; ka = 0;  lastact[0] = -1;

	if (knt<qpr) { printf("generate summary %s\n",list[aabb[0]]);
	  for (k=1;k<5;k++) printf("%s\n",list[klist+k]);
	}
	    whos[0] = dirs[0] = specials[0] = 0; kw = kd = spek = 0;
     for (k=0;k<ox;k++) { new = occ[k]; news = new/20; 

// try to find/indicate phrases...
       if (olds<news) { pun = 2; old = new; olds = news; phi = k; }  
          else if (old<new) { pun = 1;; old = new; phi = k; }  
       if (new>=100) pun = 0;

  if (phi>plo) { int dig, much=0;
// ******  would look for combos here, before phrase output
//    120.11 move combine() to after initial parse() above 
	 for (ki=plo;ki<phi;ki++) { catk = occ[oCat+ki]; codk = occ[oCod+ki];
# if (0)
     //  depends on specific values for ACT==1, WHO==2, DIR==3, MANY==4
	   if (catk>ZERO && catk<MANY && codk>0) { kp[catk]++; 
	     if (catk==ACT && kp[1]>1) str_cat(dance[catk],"_");
	     str_cat(dance[catk],out_str[codk]);  
           } /* if (catk<MANY) */
# endif
// 131.21 code to remove dependency   NB catk==PART is invisible
	   if (catk==ACT && codk>0) { lastact[ka] = codk; spek++; 
	       if (spek>1) str_cat(specials,"_"); 
	       str_cat(specials,out_str[codk]); }
	   else if (catk==WHO && codk>0) { str_cat(whos,out_str[codk]); kw++; }
	   else if (catk==DIR && codk>0) { str_cat(dirs,out_str[codk]); kd++; }
	   else if (catk==MANY) { dig = out_str[codk][0];  // kp[catk]++;
	     //	          if ('0'<dig && dig<'5') much += dig - '0'; 
	     if ('0'<dig && dig<'9') much += dig - '0'; // cope with "1.5"
	   } /* else (catk==MANY) */
	  if (knt<qpr) printf("summ %s  phr %d catk %d codk %d  much %d\n",
			      out_str[codk],occ[ki],catk,codk,much);
	 }  /* for (ki) */
 // 131.21  revert to whos, dirs, specials
         if (kw) { str_cat(so,whos); str_cat(so," "); }   // who
	 if (spek) str_cat(so,specials);                   // figure
	 if (kd) { str_cat(so,"-");  str_cat(so,dirs); }  // direction
	 // if (knt<qpr) printf(">>>> %s %s %s\n",who,specials,dirs);
	 if (much>0) { *st = much + '0'; st[1] = 0;  
	                 str_cat(so,st); } // how far

	 if (pun==2) { str_cat(so,"; ");     // end of two phrases: AABB
                       if (news<100) { ka++; lastact[ka] = 0; }
	 } else if (pun==1) str_cat(so,", ");
 // reset markers for next phrase
       	 plo = phi; pun = 0; // dance[1][0] = dance[2][0] = dance[3][0] = 0;
         ka++; lastact[ka] = -1; // for (ki=0;ki<5;ki++) kp[ki] = 0; 
	    whos[0] = dirs[0] = specials[0] = 0; kw = kd = spek = 0;
 } /* if (phi>plo)   search pseudo phrase */

     } /* for (k<ox) */

     csvoutstr(so); csvoutnum(0);   // summary and blank column 

   //   printf("########## %d %d %s %s \n  \n",su,so,su,so);  
// debug mark end of dance...
	if (fa) { fprintf(fa,"%s\n\n",so);
	  for (k=0;k<ka;k++) { int lac=lastact[k]; char *prose;
	    if (lac==0) fprintf(fa,"; "); // print up to 3 chars 
	    else if (lac<0)  fprintf(fa,"- "); 
	    else if (lac<kout) { if (out_str[lac]==0) fprintf(fa,"<> "); 
	      else { char cn[20]; str_ncpy(cn,out_str[lac],10); 
		     cn[3] = 0; fprintf(fa,"%s ",cn); }
            }  } 
	  fprintf(fa,"\n\n"); 
 /* debug 131.13 */
	fprintf(fa,"ka %d,  ",ka);  
	  for (k=0;k<ka;k++) fprintf(fa," %d",lastact[k]);
	  fprintf(fa,"\n\n");
/* debug */
	}  /* if (fa) */

	if (knt<qpr) { printf("%s\n\n",so);
	  for (k=0;k<ka;k++) { int lac=lastact[k]; char *prose;
	    if (lac==0) printf("; "); // print up to 3 chars 
	    else if (lac<0)  printf("- "); 
	    else if (lac<kout) { if (out_str[lac]==0) printf("<> "); 
	      else { char cn[20]; str_ncpy(cn,out_str[lac],10); 
		     cn[3] = 0; printf("%s ",cn); }
            }  } 
	  printf("\n\n");  }  /* if (knt<qpr) */
// ******** now analyse occ[] for phrases, etc...

qpr = qprst;       //   /*debug */  if (qpr>=0) { 
 
if (knt<qpr) printf("======= csv stat columns kdance %d\n",kdance);
             k = str_len(so);     // keep maximum usage (summary)
             if (use_su<k+so-su) use_su = k+so-su; 
        so = st; smx = stmx;  // base and limit for statistics strings  
	  k = 50*kcol;
            for (i=0;i<k;i++) so[i] = 0; // so += 1000;
	    ix[0] = jj = ii = 0; kk = 1; old = occ[0]; olds = old/20;
	    for (i=0;i<kcol;i++) { knt_col[i] = spec[i] = kp[i] = 0;
	      tabu[i][0] = 0; dance[i] = so; so += 50; }
	    whos[0] = dirs[0] = specials[0] = 0; kw = kd = 0;
           ka = 0;   lastact[0] = -1;
       for (k=0;k<ox;k++){  new = occ[k]; news = new/20;
	    catk = occ[oCat+k]; codk = occ[oCod+k];
// new dict,  key is ocodes[i]
	     if (knt<qpr) printf("k %d phr %d cat %d cod %d out %s\n",
		                  k,new,catk,codk,out_str[codk]);
// end of phrase (',' or ';' or '\\' separated: mess with qualifiers
	    if (new>old) { ix[kk] = k; old = new; kk++;  
	      for (i=0;i<kcol;i++) { is = col_info[i]; jj = 0;
		if (is==QUALIFY || is==ORDER) 
		{ kw = kp[i]; kd = knt_col[i];
		  for (j=kw;j<kd;j++) if (tabu[i][j]<0) jj++;
		  if (jj==0) knt_col[i] = kw; // forget them
		  else { int kq=0; 
                    // rewrite, drop manditory, unless no qualifiers (hey)
		    for (j=kw;j<kd;j++) { codk = tabu[i][j];
		      if (codk>0) { tabu[i][kw] = codk; kw++; kq++; }
		    }  /* for (j<kd) */
		  if (is==QUALIFY)
		  { if (kq==0 && jj>0) { tabu[i][kw] = -tabu[i][jj]; kw++; } }
		  else if (is==ORDER && kq>0)
                       { for (j=kq=0;j<=ka;j++) if (lastact[j]>0) kq++;
                         kw = kp[i]; tabu[i][kw] = kq; kw++; /* ORDER */ }   
		    knt_col[i] = kw; }  /* else rewrite qualifiers */
		} /* if (is==QUALIFY || is==ORDER) */
                else if (is==SYNOPSIS && kw==kd) 
                  { tabu[i][kw] = -kout; knt_col[i]++; }
	      } /* for (i<kcol) */
  // reset beginning of phrase counters...
	      for (i=0;i<kcol;i++) kp[i] = knt_col[i]; ka++; // move on...
	      if (news>olds) { jj = 0;  olds = news;
                if (news<100) { lastact[ka] = 0; ka++;} }
       }  /* if (new>old) */
//  tabulate info for each k in each pseudo phrase (old==new)  
 	      catk = occ[oCat+k]; codk = occ[oCod+k];  // refresh catk & codk
	    if (codk>0) { if (catk==ACT) lastact[ka] = codk;
              for (i=0;i<kstat;i++) { cs = stat_col[i]; is = stat_info[i];   
                if (codk==stat_code[i]) {
	 	  if (is == PIECES)  // record codk, strain, and print to info.
                    { int k, kcs = knt_col[cs]; 
		      tabu[cs][kcs] = codk; tabu[cs][kcs+1] = news;  
    //  if (fa) { for (k=0;k<kcs;k++) fprintf(fa,"%d ",tabu[cs][k]);
   //     fprintf(fa,"pieces knt %d  code %d strain %d\n", kcs, codk, news);  }
                     knt_col[cs] += 2; }
		  else if (is>=0) 
		    { tabu[cs][knt_col[cs]] = codk; knt_col[cs]++; }
		  else if (is != -PIECES)     // flag manditory
                    { tabu[cs][knt_col[cs]] = -codk; knt_col[cs]++; };
		} /* if (codk==stat_code[]) */
	      } /* for (i<kstat) */
	    } /* if (codk>0) (catk==ACT)  check for columns */
	      //   if (jj) { for (i=0; i<jj; i++) str_cat(dance[kp[i]],dirs); }
       } /* for (k<ox) */

	if (knt<qpr) printf("possible phrases %d %s [sw] \n",kk,dance[1]);
	hist[hPun-24+kk]++;  hist[hPun+31+ii]++;
	if (knt<qpr) {for (i=0;i<kcol;i++) { printf(" %d",knt_col[i]); 
	    if (dance[i][0]!=0) printf(" %s",dance[i]); }
	      printf("\n>>>>%s %s %s\n",specials,dance[1],dance[2]); }
	//	csvoutstr(specials);
	//      for (i=1;i<kcol;i++) csvoutnum(knt_col[i]);

	//    qpr = 0;

 /* debug 131.13 */
            for (k=kk=0;k<ka;k++) if (lastact[k]>0) kk++;
      if (fa) {
	  fprintf(fa,"ka %d kq %d,  ",ka,kk);  
	    for (k=0;k<ka;k++) fprintf(fa," %d",lastact[k]);
	  fprintf(fa,"\n\n");
      } /* if (fa) */

// had AA BB AABB title output here; move to end
# if (0)
  for (i=0;i<kcol;i++) { if (col_info[i] == PIECES && fa)  
      { int k, kcs = knt_col[i]; 
	for (k=0;k<kcs;k++) fprintf(fa,"%d ",tabu[i][k]); 
        fprintf(fa," before stat loop pieces col %d \n",i);  }  }
# endif
// statistics columns 
    for (i=ki=0;i<kcol;i++) {  is = col_info[i]; kk = knt_col[i];
	    dance[i][0] = ' ';     dance[i][1] = 0;  
      switch(is) {
      case COUNT: csvoutnum(kk); continue; 
      case PIECES:  { int uab[5]; // check again...
	    if (fa) { for (k=0;k<kk;k++) fprintf(fa,"%d ",tabu[i][k]); 
		      fprintf(fa," line 1262 pieces col %d \n",i);  }  
 // eliminate doubles, count strains with flags (e.g. "return") as one
	    for (k=0,kd=1;k<ka && kd<5;k++) { jj = ix[j] = lastact[k]; 
	      if (jj>0) j++;  else if (jj==0) 
		{ uab[kd] = uniquify(j,ix); j = 0; kd++; } }  /* k<ka.. */
// if section is flagged, revise count ( can extend revision to "#n" )  
	    for (k=1;k<kk;k+=2) { uab[tabu[i][k]] = 1; }  
	    ii = 0; for (k=1;k<5;k++) ii += uab[k];
	    csvoutnum(ii); 
	    if (fa) fprintf(fa,"-------------\n\n");
	    continue; } /* PIECES: approximate piece count */
      case SYNOPSIS: kk = ka; for (k=0;k<ka;k++) tabu[i][k] = lastact[k]; 
	    str_cat(dance[i],"  ");
	    for (k=0;k<kk;k++) { codk = tabu[i][k]; 
	      if (codk==0) { str_ncat(dance[i],";",1); } 
	      if (codk<0)  { str_ncat(dance[i],"X",1);  }
              else str_ncat(dance[i],out_str[codk],1); 
            } /*for (k<kk) */
	    csvoutstr(dance[i]); continue;  /* SYNOPSIS */
      case TEXT: /* full text */  kk = uniquify(kk,tabu[i]); 
	    for (k=0;k<kk;k++) { str_cat(dance[i],out_str[tabu[i][k]]);
	                         str_cat(dance[i]," "); }
            csvoutstr(dance[i]); continue; 
      case FIRST_CHAR: kk = uniquify(kk,tabu[i]); 
	    for (k=0;k<kk;k++) { codk = tabu[i][k]; 
	      if (codk>=kout) printf("codk %d >> kdance %d k %d\n",
                                      codk,kdance,k); else
	      if (codk<0)  { str_ncat(dance[i],"?",1); 
	      } else str_ncat(dance[i],out_str[codk],1); } /*for (k<kk) */
	    csvoutstr(dance[i]); continue;  /* FIRST_CHAR */
      case QUALIFY:     kk = uniquify(kk,tabu[i]); 
	    for (k=0;k<kk;k++) { codk = tabu[i][k]; 
	      if (codk>=kout) printf("codk %d >> kdance %d k %d\n",
                                      codk,kdance,k); else
	      if (codk<0)  {  str_ncat(dance[i],"#",1); 
	      } else str_ncat(dance[i],out_str[codk],1); } /*for (k<kk) */
	    csvoutstr(dance[i]); continue;  /* QUALIFY */
      case GROUP:    kk = klusters[i]; 
	    kluster = klust_cols + kk;  ii = 0; klust = kluster[0];
	    for (k=1;k<=klust;k++) if (knt_col[kluster[k]]) ii = 10*ii + k;
	    fprintf(fo,"%d,",ii);   // columns with non-zero counts
	    if (knt<qpr) 
              printf("col %d klust %d col1 %d ii %d\n",i,klust,kluster[1],ii);
	    continue;   /* GROUP  check knt_col for occupancies */
      case ORDER: k = knt_col[i]; if (k>0) k = 10*tabu[i][0] + k; 
	    // somehow, tabu[i][0] == ka or something if knt_col[i] == 0
            //               csvoutnum(k); continue; } /* ORDER */
	    k = knt_col[i];  if (k==0) { csvoutnum(0); continue; }
	    sprintf(whos,"'%2d",tabu[i][0]);
	    for (kk=1;kk<k;kk++) 
              { sprintf(dirs," %d",tabu[i][kk]); str_cat(whos,dirs); }
	    csvoutstr(whos); continue;  /* ORDER: move sequence in dance */
      case -PIECES:  csvoutstr(zesty);
	    continue;  /* -PIECES: "zesty" string, if it exists */
      default:  ki++; kerr++; continue; // error, shouldn't get here
      }  /* switch (is) */
    } /* for (i<kcol) */

    if (ki) printf("#### incomplete stats: dance %d miss %d\n",kdance,ki);

// repeat title for ease of reading, then statistics 
	csvoutstr(title);

if (knt<100 && qexpt) printf("#####  knt %4d qexpt %d %x \n",knt,qexpt,qexpt);
if (qexpt) {  // output AA BB AABB only if "-e" in command line
	// uniqified synopsis: (lastact[k]==0) ';' separates double phrases
	for (k=ii=kk=0,jj=-1;k<ka;k++) { i = ix[kk] = lastact[k];
	  if (i<0) { ix[kk] = -1; if ((i+kout)>0) kk++; }
	  else if (i>0 && i<kout) kk++; 
          else if (i==0) { if (ii==1) jj = kk; ii++; }  // split AA BB 
        } /* for (k<ka) */
   // unique actions in A1A2
	ii = jj; jj = uniquify(jj,ix); whos[0] = 0;
	for (k=0;k<jj;k++) { i = ix[k]; 
	  if (i>0) str_ncat(whos,out_str[i],1); else str_cat(whos,"X"); }
	csvoutstr(whos); 
  // unique actions in B1B2
	for (k=ii;k<kk;k++) ix[k-ii] = ix[k];  // drop
	kk = uniquify(kk-ii,ix); whos[0] = 0;
	for (k=0;k<kk;k++) { i = ix[k]; 
	  if (i>0) str_ncat(whos,out_str[i],1); else str_cat(whos,"X"); }
	csvoutstr(whos);
 
  // unique actions in A1A2B1B2
	for (k=kk=0;k<ka;k++) { i = ix[kk] = lastact[k];
	  if (i<0) { ix[kk] = -1; if ((i+kout)>0) kk++; }
	  else if (i>0 && i<kout) kk++; 
        } /* for (k<ka) */
	kk = uniquify(kk,ix); whos[0] = 0;
	for (k=0;k<kk;k++) { i = ix[k]; 
	  if (i>0) str_ncat(whos,out_str[i],1); else str_cat(whos,"X"); }
	csvoutstr(whos); 
 }  /* if (qexpt)   conditional output */

    fprintf(fo,"%d\n",kdance);  // terminate csv line with sort key
    //  }  /* debug */   // if (qpr>=0) */
   }  /* end local block { int  */

  } /* if (qcsv) */
}  /* else (!qdict) */
// reset pointers and buffer
    if (use_st<so-st) use_st = so - st;  if (use_ox<ox) use_ox = ox;
      so = sl; kk = aabb[5];  klist = 0; phead = -1;
      if (kk>0 && list[kk][0]=='=')
	{ if (knt<qpr) printf(">>>move %s\n",list[kk]);
        klist = 1; list[0] = so; si = list[kk]; n = str_len(si);
	for (i=0; i<n; i++) { *so = si[i]; so++; };  
           *so = 0; if (so<smx) so++;  }  
         kblnk = kab = nab = qhead = 0; for (i=0;i<6;i++) aabb[i] = 0;
	 // comments/blanks from previous dance may be saved before new title??
     }  // check for complete dance -- 

 } /* while (1) get and parse lines */

      pr_storage(stdout); pr_storage(fa);
      pr_summary(stdout,0); pr_summary(fa,1);

# if (0)
      printf("\n dances read from:      %s\n",filein);
      printf("\n dictionary from:       %s\n",filedict);
      printf("\n statistics setup from: %s\n\n",filestat);

  printf("dances %d  heads %d k3  %d\n",kdance,khead,k3);
  printf("tokens %d combos %d not combined %d   strange char %d\n",
	 kd,kombin,unkomb,krazy);
  if (fa) { 
    fprintf(fa,"dances %d  heads %d k3  %d\n",kdance,khead,k3);
    fprintf(fa,"tokens %d combos %d not combined %d\n",kd,kombin,unkomb);
    fprintf(fa,"\nhist[224+9*semi+3*comma+lines]");
    fprintf(fa,"\nsepar       paren        tokens\n");
    for (i=0;i<25;i++) 
    { for (j=0;j<300;j+=25) fprintf(fa,"%5d",hist[i+j]); fprintf(fa,"\n"); }
  } /* if (fa) */ 
  if (fa) fprintf(fa,"\n\n==========undecoded %d\n\n\n",hist[hOcc]);
  printf("\n\n============undecoded %d\n\n",hist[hOcc]);

  printf("string storage (bytes): dictionary and analysis %d input lines %d\n"
         "     summary %d statistics %d\n",use_sd,use_sl,use_su,use_st);
  printf(" parameter counts (<%d): kout %d kin %d combo %d statistics %d\n",
	 Ms,kout,ksear,kombo,kstat);
  printf("max moves %d (<%d), statistics columns %d (<%d)\n"
         "errors (check stdout) %d \n=================\n\n",
	 use_ox,Mox/4,kcol,Mi,kerr);

    for (j=1;j<kout;j+=5) { for (i=0; (i<5 && i+j<kout); i++)  
	{   if (fa) fprintf(fa,"%s\t%4d    ",out_str[i+j],hist[hOcc+i+j]); 
            printf("%s\t%4d    ",out_str[i+j],hist[hOcc+i+j]); }
      if (fa) fprintf(fa,"\n");  printf("\n"); }  /* for (j<kout) */
# endif

    fclose(fi); if (qcsv && fo) fclose(fo);  if (fa) fclose(fa);

 if (qdict) { kk = 0; for (k=0;k<kd;k++) kk += occ[k];
    printf("=== writing %d unique tokens, %d total\n to %s, %s\n",
              kd,kk,fileglos,"occ.out");
    fo = openfile(fileglos,defaultglos,"w");
    if (fo) { ksort(kd,occ,dict);  // sort by frequency
       for (k=0; k<kd; k++) fprintf(fo,"%4d   %s\n",occ[k],dict[k]);
       fclose(fo); }  /* if (fo) */
    fo = fopen("occ.out","w"); 
    if (fo) {
      ssort(kd,dict,occ);
      for (k=0; k<kd; k++) fprintf(fo,"%4d   %s\n",occ[k],dict[k]);
      fclose(fo); }  /* if (fo) */
 } /* if (qdict) */

  exit(0);  
}  /* main() */

void pr_summary(FILE *f, int histo)  // end of program summary
{ int i,j;      if (!f) return;

  fprintf(f,"\n dances read from:      %s\n",filein);
  fprintf(f,"\n dictionary from:       %s\n",filedict);
  fprintf(f,"\n statistics setup from: %s\n\n",filestat);

    fprintf(f,"dances %d  heads %d k3  %d\n",kdance,khead,k3);
    fprintf(f,"tokens %d combos %d not combined %d\n\n",kd,kombin,unkomb);
    if (krazy) fprintf(f,"untranslated strange characters %d\n\n",krazy);
    if (kerr) fprintf(f,"\n#### errors (check stdout) %d ####\n\n",kerr);
 if (histo) // bare histogram numbers to info.out 
    { fprintf(f,"\nhist[224+9*semi+3*comma+lines]");
      fprintf(f,"\nsepar       paren        tokens\n");
      for (i=0;i<25;i++) 
      { for (j=0;j<300;j+=25) fprintf(f,"%5d",hist[i+j]); fprintf(f,"\n"); }
      fprintf(f,"\n\n==========undecoded %d\n\n\n",hist[hOcc]);
    } /* if (histo) */
 // tallies of out_symbol occurrences
    for (j=1;j<kout;j+=5) { 
        for (i=0; (i<5 && i+j<kout); i++)  
	  { fprintf(f,"%s\t%4d    ",out_str[i+j],hist[hOcc+i+j]); }
        fprintf(f,"\n"); }  /* for (j<kout) */
        fprintf(f,"\n");
}  /* pr_summary() 131.22 */

void pr_storage(FILE *f)  // info about storage usage
{     if (!f) return;
  fprintf(f,"string storage (bytes): dictionary and analysis %d"
    "  input processing %d\n     summary %d statistics %d\n",
    use_sd,use_sl,use_su,use_st);
  fprintf(f," parameter counts (<%d): kout %d kin %d combo %d statistics %d\n",
	  Ms,kout,ksear,kombo,kstat);
  fprintf(f,"max moves %d (<%d), statistics columns %d (<%d)\n",
	 use_ox,Mox/4,kcol,Mi);
  fprintf(f,"\n--------------------\n\n");
} /* pr_storage()  131.22 */
